Overview | Modules | Class Hierarchy | Classes | Members

# tlp::ObservableGraph Class Reference
[Graphs]

`#include <ObservableGraph.h>`

Inherited by tlp::Graph.

Inheritance diagram for tlp::ObservableGraph:

[legend]
List of all members.

## Detailed Description

Observable object for graph.

## Public Member Functions

- virtual ~ObservableGraph ()
- void addGraphObserver (GraphObserver *) const
- unsigned int countGraphObservers ()
- void removeGraphObserver (GraphObserver *) const
- void removeGraphObservers ()

## Protected Member Functions

- void notifyAddNode (Graph *, const node n)
- void notifyAddEdge (Graph *, const edge e)
- void notifyDelNode (Graph *, const node n)
- void notifyDelEdge (Graph *, const edge e)
- void notifyReverseEdge (Graph *, const edge e)
- void notifyAddSubGraph (Graph *, Graph *)
- void notifyDelSubGraph (Graph *, Graph *)
- void notifyAddLocalProperty (Graph *, const std::string &)
- void notifyDelLocalProperty (Graph *, const std::string &)
- void notifyBeforeSetAttribute (Graph *, const std::string &)
- void notifyAfterSetAttribute (Graph *, const std::string &)
- void notifyRemoveAttribute (Graph *, const std::string &)
- void notifyDestroy (Graph *)
- void removeOnlyGraphObserver (GraphObserver *) const

## Protected Attributes

- stdext::slist< GraphObserver * > observers

## Friends

- class GraphObserver

## Constructor & Destructor Documentation

virtual tlp::ObservableGraph::~ObservableGraph | ( |  | ) | `[inline, virtual]`

## Member Function Documentation

void tlp::ObservableGraph::addGraphObserver | ( | GraphObserver * |  | ) | const

| Register a new observer

unsigned int tlp::ObservableGraph::countGraphObservers | ( |  | ) | `[inline]`

| Returns the number of observers

void tlp::ObservableGraph::notifyAddEdge | ( | Graph * | ,
|  | const edge | e
| ) | `[protected]`

void tlp::ObservableGraph::notifyAddLocalProperty | ( | Graph * | ,
|  | const std::string & |
| ) | `[protected]`

void tlp::ObservableGraph::notifyAddNode | ( | Graph * | ,
|  | const node | n
| ) | `[protected]`

void tlp::ObservableGraph::notifyAddSubGraph | ( | Graph * | ,
|  | Graph * |
| ) | `[protected]`

void tlp::ObservableGraph::notifyAfterSetAttribute | ( | Graph * | ,
|  | const std::string & |
| ) | `[protected]`

void tlp::ObservableGraph::notifyBeforeSetAttribute | ( | Graph * | ,
|  | const std::string & |
| ) | `[protected]`

void tlp::ObservableGraph::notifyDelEdge | ( | Graph * | ,
|  | const edge | e
| ) | `[protected]`

void tlp::ObservableGraph::notifyDelLocalProperty | ( | Graph * | ,
|  | const std::string & |
| ) | `[protected]`

void tlp::ObservableGraph::notifyDelNode | ( | Graph * | ,
|  | const node | n
| ) | `[protected]`

void tlp::ObservableGraph::notifyDelSubGraph | ( | Graph * | ,
|  | Graph * |
| ) | `[protected]`

void tlp::ObservableGraph::notifyDestroy | ( | Graph * |  | ) | `[protected]`

void tlp::ObservableGraph::notifyRemoveAttribute | ( | Graph * | ,
|  | const std::string & |
| ) | `[protected]`

void tlp::ObservableGraph::notifyReverseEdge | ( | Graph * | ,
|  | const edge | e
| ) | `[protected]`

void tlp::ObservableGraph::removeGraphObserver | ( | GraphObserver * |  | ) | const`[inline]`

| Remove an observer

void tlp::ObservableGraph::removeGraphObservers | ( |  | ) |

| Remove all observers

void tlp::ObservableGraph::removeOnlyGraphObserver | ( | GraphObserver * |  | ) | const`[inline, protected]`

## Friends And Related Function Documentation

friend class GraphObserver `[friend]`

## Member Data Documentation

stdext::slist<GraphObserver*> tlp::ObservableGraph::observers `[mutable, protected]`

Tulip Software by LaBRI Visualization Team 2001 - 2010